# $Revision: 1.57 $, $Date: 2009/02/26 15:21:16 $
#
# Conditional build:
%bcond_with	initrd		# build initrd version (very broken)
#
Summary:	Tools to manage multipathed devices with the device-mapper
Summary(pl.UTF-8):	Implementacja wielotrasowego dostępu do zasobów przy użyciu device-mappera
Name:		multipath-tools
Version:	0.4.8
Release:	9
License:	GPL v2
Group:		Base
Source0:	http://christophe.varoqui.free.fr/multipath-tools/%{name}-%{version}.tar.bz2
# Source0-md5:	3563b863b408d07c46929b6e8c2c248c
Source1:	multipathd.init
Source2:	multipathd.sysconfig
Source3:	%{name}-bindings
Source4:	%{name}-initramfs-hooks
Source5:	%{name}-initramfs-local-top
URL:		http://christophe.varoqui.free.fr/
Patch100:	%{name}-branch.diff
Patch0:		%{name}-llh.patch
Patch1:		%{name}-kpartx-udev.patch
Patch2:		%{name}-bindings.patch
BuildRequires:	device-mapper-devel >= 1.02.08
BuildRequires:	libaio-devel
BuildRequires:	linux-libc-headers >= 2.6.12.0-5
BuildRequires:	readline-devel
BuildRequires:	sed >= 4.0
BuildRequires:	sysfsutils-devel >= 2.0.0
%if %{with initrd}
BuildRequires:	device-mapper-initrd-devel
BuildRequires:	klibc-static
%endif
Requires(post,preun):	/sbin/chkconfig
Requires:	device-mapper >= 1.02.08
Requires:	kpartx = %{version}-%{release}
Requires:	libaio >= 0.3.106-2
Requires:	rc-scripts
%if "%{pld_release}" == "ti"
Conflicts:	udev < 1:124-3
%else
Conflicts:	udev < 1:127
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin

%description
multipath-tools provides the tools to manage multipathed devices by
instructing the device-mapper multipath module what to do. The tools
are:
- multipath: scan the system for multipathed devices, assembles them
  and update the device-mapper's maps
- multipathd: wait for maps events, then execs multipath
- devmap-name: provides a meaningful device name to udev for devmaps

%description -l pl.UTF-8
multipath-tools zawierają narzędzia do zarządzania wielotrasowym
dostępem do urządzeń poprzez instruowanie modułu multipath
device-mappera. Narzędzia to:
- multipath - przeszukuje system pod kątem urządzeń z dostępem
  wielotrasowym, łączy je i uaktualnia odwzorowania device-mappera
- multipathd - oczekuje na zdarzenia odwzorowań, po których uruchamia
  multipath
- devmap-name - dostarcza do udev znaczącą nazwę urządzenia dla map
  urządzeń

%package -n kpartx
Summary:	Partition device manager for device-mapper devices
Summary(pl.UTF-8):	Zarządca urządzeń partycji dla urządzeń device-mappera
Group:		Base
%if "%{pld_release}" == "ti"
Requires:	udev-core >= 1:124-3
%else
Requires:	udev-core >= 1:127
%endif

%description -n kpartx
kpartx maps linear devmaps upon device partitions, which makes
multipath maps partionable.

%description -n kpartx -l pl.UTF-8
kpartx odwzorowuje liniowe mapy urządzeń na partycje urządzeń, co
umożliwia tworzenie partycji na odwzorowaniach wielotrasowych.

%package initramfs
Summary:	Tools to manage multipathed devices with the device-mapper - support scripts for initramfs-tools
Summary(pl.UTF-8):	Wielotrasowy dostęp do zasobów przy użyciu device-mappera - skrypty dla initramfs-tools
Group:		Base
Requires:	%{name} = %{version}-%{release}
Requires:	initramfs-tools

%description initramfs
Tools to manage multipathed devices with the device-mapper - support
scripts for initramfs-tools.

%description initramfs -l pl.UTF-8
Wielotrasowy dostęp do zasobów przy użyciu device-mappera - skrypty
dla initramfs-tools.

%prep
%setup -q
%patch100 -p1
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
%if %{with initrd}
%{__make} -j1 \
	BUILD=klibc \
	CC="klcc -static" \
	OPTFLAGS="%{rpmcflags} -Wall -Wunused -Wstrict-prototypes" \
	BUILDDIRS='multipath pathx' \
	klibcdir=%{_libdir}/klibc \
	libdm='$(klibcdir)/libdevmapper.a'

%{__make} clean
%endif

%{__make} -j1 \
	OPTFLAGS="%{rpmcflags} -Wall -Wunused -Wstrict-prototypes" \
	CC="%{__cc}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/{hooks,scripts/local-top}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -D multipath.conf.annotated $RPM_BUILD_ROOT%{_sysconfdir}/multipath.conf
install -D %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/multipathd
install -D %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/multipathd
install -D %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/multipath/bindings
mv $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/{,40-}multipath.rules
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/dev.d/block/multipath.dev

install %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/hooks/multipath
install %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/scripts/local-top/multipath

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add multipathd
%service multipathd restart

%preun
if [ "$1" = "0" ]; then
	%service multipathd stop
	/sbin/chkconfig --del multipathd
fi

%files
%defattr(644,root,root,755)
%doc AUTHOR ChangeLog FAQ README TODO
%attr(755,root,root) %{_sbindir}/kpartx
%attr(755,root,root) %{_sbindir}/multipath
%attr(755,root,root) %{_sbindir}/multipathd
%dir /lib/multipath
%attr(755,root,root) /lib/multipath/lib*.so
%attr(754,root,root) /etc/rc.d/init.d/multipathd
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/multipathd
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/multipath.conf
%dir %{_sysconfdir}/multipath
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/multipath/bindings
%{_sysconfdir}/udev/rules.d/40-multipath.rules
%{_mandir}/man5/multipath.conf.5*
%{_mandir}/man8/multipath.8*
%{_mandir}/man8/multipathd.8*

%files -n kpartx
%defattr(644,root,root,755)
%doc kpartx/README
%attr(755,root,root) /lib/udev/kpartx_id
%{_sysconfdir}/udev/rules.d/kpartx.rules
%{_mandir}/man8/kpartx.8*

%files initramfs
%defattr(644,root,root,755)
%attr(755,root,root) %{_datadir}/initramfs-tools/hooks/multipath
%attr(755,root,root) %{_datadir}/initramfs-tools/scripts/local-top/multipath

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: multipath-tools.spec,v $
Revision 1.57  2009/02/26 15:21:16  baggins
- rel 9

Revision 1.56  2009/02/26 15:12:45  baggins
- added initramfs subpackage (NEED TESTERS)

Revision 1.55  2009/02/26 14:32:57  baggins
- added initramfs support files to package

Revision 1.54  2009/02/23 22:07:13  arekm
- release 8

Revision 1.53  2009/02/10 21:51:18  hawk
- blah, one more udev R fix for Titanium

Revision 1.52  2009/02/10 21:29:01  hawk
- udev > 124 is too unstable for Titanium

Revision 1.51  2009/01/01 20:14:27  baggins
- rel 5
- updated to 01.01.2009 GIT

Revision 1.50  2008/11/26 14:25:25  glen
- udev epoch everywhere

Revision 1.49  2008/11/25 22:44:11  baggins
- rel 4
- now it actually works on current Th

Revision 1.48  2008/11/25 22:41:09  baggins
- no need to sed the Makefile
- multipath libs are in /lib on all archs

Revision 1.47  2008/11/25 22:33:02  baggins
- updated to today's GIT
- updated files
- udev 127 and later has all stuff in /lib on all archs

Revision 1.46  2008/07/14 12:26:55  glen
- fix for /lib64/udev

Revision 1.45  2008/07/11 15:43:23  qboosh
- libaio is (almost) everywhere now

Revision 1.44  2008/07/11 05:24:50  glen
- BR-ed libaio not present on sparc; rel 3

Revision 1.43  2008/07/10 08:57:38  glen
- use lib64 udev dir for kprtx

Revision 1.42  2008-05-27 17:38:31  qboosh
- pl summary for kpartx

Revision 1.41  2008-05-24 00:24:57  glen
- separate package for kpartx; rel 2

Revision 1.40  2007-12-15 14:39:18  glen
- rel 1

Revision 1.39  2007-11-14 14:20:35  glen
- move bindings file to /etc/multipath/bindings

Revision 1.38  2007-11-13 23:14:01  glen
- add branch.diff

Revision 1.37  2007/10/26 12:50:58  glen
- install sysconfig

Revision 1.36  2007/10/26 12:04:23  glen
- add kpartx udev files fix
- restart multipathd normal way (i see no reason why not)

Revision 1.35  2007/10/25 16:57:25  glen
- require libaio in /%{_lib}

Revision 1.34  2007/10/25 12:27:31  glen
- # multipath -l :
  libdevmapper version must be >= 1.02.08

Revision 1.33  2007/10/24 15:40:01  glen
- typo

Revision 1.32  2007/10/24 15:11:22  glen
- chkconfig

Revision 1.31  2007/10/23 16:37:54  glen
- try initrd building

Revision 1.30  2007/10/18 16:23:42  glen
- typo

Revision 1.29  2007/10/18 16:21:58  glen
- add initscript
- add %pre and %post scripts to stop multipathd during update (novell bug #229950)

Revision 1.28  2007/10/16 15:41:54  glen
- device-mapper-devel >= 1.02.07 for dm_task_skip_lockfs symbol
- /lib/udev is the installed path on amd64

Revision 1.27  2007/09/09 23:30:14  qboosh
- updated to 0.4.8
- removed obsolete optflags patch, dropped unneeded selinux patch

Revision 1.26  2007/02/13 07:16:49  glen
- tabs in preamble

Revision 1.25  2007/02/12 00:49:08  baggins
- converted to UTF-8

Revision 1.24  2006/08/19 20:58:17  qboosh
- removed never used initrd part

Revision 1.23  2006/08/19 20:57:02  qboosh
- updated optflags patch is back; udev patch not used - is it still needed?

Revision 1.22  2006/07/30 19:44:08  glen
- no reason to keep multipathd separately in /usr/sbin
- verbose files back!
- bashism.patch looks outdated, optflags patch needs update!

Revision 1.21  2006/07/29 18:20:07  aredridel
- 0.4.7

Revision 1.20  2006/02/25 18:00:57  qboosh
- real pl desc, note about patch for libsysfs2 API

Revision 1.19  2006/02/25 01:01:08  aredridel
- incompatible with new sysfsutils

Revision 1.18  2005/10/17 09:19:50  glen
- don't enforce udev, leave room for static dev

Revision 1.17  2005/10/16 00:38:00  glen
- GPL v2

Revision 1.16  2005/10/16 00:30:50  glen
- apply patch3

Revision 1.15  2005/10/16 00:30:16  glen
- possible __kernel_old_dev_t typedef fix for alpha

Revision 1.14  2005/10/16 00:15:12  glen
- force llh for alpha builder

Revision 1.13  2005/10/15 23:58:04  glen
- udev rules file fix

Revision 1.12  2005/10/15 23:36:21  glen
- up dm req (from homepage)
- apply optflags

Revision 1.11  2005/10/15 23:34:33  glen
- optflags patch

Revision 1.10  2005/10/15 23:24:47  glen
- added docs

Revision 1.9  2005/10/15 23:22:11  glen
- multipathd to /usr/sbin

Revision 1.8  2005/10/15 23:19:14  glen
- BR device-mapper

Revision 1.7  2005/10/15 23:15:36  glen
- udev.d obsolete
- sortnr to .rules

Revision 1.6  2005/10/15 23:07:05  glen
- BR: readline-devle

Revision 1.5  2005/10/15 22:48:22  glen
- bash fix, pass CC

Revision 1.4  2005/10/15 22:45:09  glen
- update summary/description from sources
- resolve udev conflict

Revision 1.3  2005/10/15 22:28:25  glen
- 0.4.5; completed %files

Revision 1.2  2004/12/25 16:51:49  qboosh
- pl, removed template changelog

Revision 1.1  2004/12/24 21:55:48  arekm
- raw
